<?

/* Include files */
include(__DIR__.'/libudp.php');

/* Some constants */
define('CHEMIN_FICHIERS','/usr/local/etc/');
define('CHEMIN_BT_ADRESSE',CHEMIN_FICHIERS.'bt_adresse');
define('MEMOIRE_PORT',3456);

/* Get our bluetooth address */
if(!is_file(CHEMIN_BT_ADRESSE)) die("Adresse bluetooth non presente");
$bta=trim(file_get_contents(CHEMIN_BT_ADRESSE));

/* Contact memory server */
$status=connectUDPServer("127.0.0.1",MEMOIRE_PORT);
if($status===false) die("Impossible de contacter le serveur UDP");
$client=$status[0];
$address=$status[1];
$memory=array();
sendUDPBroadcast($client,$address,"RETR");

/* Retreive memory */
while(true){
  $status=receiveUDPAnswer($client);
  if($status===false) break;
  if($status[1]!=$address) break;
  $data=$status[0];
  if($data[0]==' ') break;
  $parts=explode(' ',$data);
  $memory[$parts[0]][$parts[1]]=$parts[2];
  }
closeUDPClient($client);

/* Generate js to draw robots */
header("Content-type: text/javascript");
echo "<script type=\"text/javascript\">\n";
echo "clearmap();\n";
$lineColors=array(0x10=>'blue',0x12=>'red',0x14=>'yellow',0x16=>'gray');
foreach($memory as $robot => $infos){
  if($robot==$bta) $type=1; else $type=0;
  if(!array_key_exists('line',$infos)) $color="black";
  else $color=$lineColors[$infos['line']];
  if(!array_key_exists('compass',$infos)) $heading=0;
  else $heading=$infos['compass'];
  if(!array_key_exists('rfid',$infos)) $rfid=-1;
  else $rfid=$infos['rfid'];
  echo "drawrobot($type,$rfid,\"$color\",$heading);\n";
  }
echo "</script>\n";

?>
