<?php

define('MAX_BUFFER',4096);

function createUDPServer($port){
$location="udp://0.0.0.0:$port";
$stream=stream_socket_server($location,$errno,$errstr,STREAM_SERVER_BIND);
return $stream;
}

function connectUDPServer($ip,$port){
$socket=socket_create(AF_INET,SOCK_DGRAM,SOL_UDP);
if($socket===false) return false;
$status=socket_set_option($socket,SOL_SOCKET,SO_BROADCAST,1);
if($status===false) return false;
return array($socket,"$ip:$port");
}

function receiveUDPDatagram($server){
$data=stream_socket_recvfrom($server,MAX_BUFFER,0,$address);
return array($data,$address);
}

function sendUDPDatagram($server,$address,$data){
stream_socket_sendto($server,$data,0,$address);
}

function sendUDPBroadcast($client,$address,$data){
$parts=explode(':',$address);
$len=strlen($data);
socket_sendto($client,$data,$len,0,$parts[0],$parts[1]);
}

function receiveUDPAnswer($client){
$status=socket_recvfrom($client,$data,MAX_BUFFER,0,$address,$port);
if($status===false) return false;
return array($data,"$address:$port");
}

function closeUDPServer($stream){
fclose($stream);
}

function closeUDPClient($socket){
socket_close($socket);
}

?>
